
#include <iostream.h>
#include <fstream.h>
#include <string.h>

ifstream listfile;
ofstream libfile;
ifstream incfile;

int num_files = 0;
int file_pointer;

char libfname[13];
char listfname[255]="MAKELIB.TXT";
char incfname[13];
char string[200];



int file_size(char *fname)
{
int fsize;

	incfile.open(fname, ios::binary);

	incfile.seekg(0, ios::end);

	fsize = incfile.tellg();

	incfile.close();

	return fsize;
}


void build_incfname()
{
int c=0;
int ec=0;

     while (string[c]!=0 && string[c]!=46)
     {
         incfname[c]=string[c];
         c++;
     }

     ec=c;       //position of dot (if there's one)
     while (c<8)
     {
         incfname[c]=32;
         c++;//fill filename up with whitespaces
     }

     if (string[ec]==0)
     {
         incfname[8]=32;
         incfname[9]=32;
         incfname[10]=32;
     }
     else
     {
         ec++;
         while (string[ec]!=0)
         {
              incfname[c]=string[ec];
              ec++;
              c++;
         }

         while (c<11)
         {
             incfname[c]=32;
             c++;
         }
     }
}


void include_files()
{
	listfile.open(listfname);
	listfile.getline(libfname,13);	//Skip Library Name

	while (listfile.getline(string,200))
	{
		if ( (string[0] != ';') && (string[0] > 32) )
		{
			cout << "Including " << string << "...";

			int fsize = file_size(string);

			char *buffer = new char[fsize];

			incfile.open(string,ios::binary);
			incfile.read(buffer, fsize);
			libfile.write(buffer,fsize);

			delete [] buffer;
			
			incfile.close();
			cout << "Done." << endl;
		}
	}

	listfile.close();
	libfile.close();
}


/*Build the library's directory
  Format: 2 bytes: number of files in directory
          per file: 5 bytes: file-info
                              2 bytes: filesize
                              3 bytes: position in library
          1 byte: closing zero
*/
void build_directory()
{
unsigned char byte;
int fsize;

    cout << "Building library directory...";

    //calculate position of first file in directory
	file_pointer = 2 + 6 * num_files;

    listfile.open(listfname);
    listfile.getline(libfname,13);      //Read Library Name
	cout << libfname;
    libfile.open(libfname, ios::binary);

    byte = (unsigned char)num_files;
    libfile.write( (char*)&byte,1);
    byte = (unsigned char)(num_files >> 8);
    libfile.write( (char*)&byte,1);     //write num_files to file

    while (listfile)
    {
        listfile.getline(string,200);
        if (string[0]>64)            //if it's a filename
		{
			 //little endian byte order, so output per byte for compatibility
             fsize = file_size(string);//get the size of the file
             byte = (unsigned char)(fsize%256);
             libfile.write( (char*)&byte,1);
             byte = (unsigned char)(fsize/256);
             libfile.write( (char*)&byte,1);//and store it in the directory
             byte = (unsigned char)((fsize >> 16)%256);
             libfile.write( (char*)&byte,1);//in the directory

             byte = (unsigned char)(file_pointer%256);
             libfile.write( (char*)&byte,1);//Store the position
             byte = (unsigned char)((file_pointer >> 8)%256);
             libfile.write( (char*)&byte,1);//of this file
             byte = (unsigned char)((file_pointer >> 16)%256);
             libfile.write( (char*)&byte,1);//in the directory

             file_pointer+=(int)fsize;
        }
    }

    cout << "done." << endl;
    listfile.close();
}


void count_files()
{
    cout << "Counting number of files...";

    listfile.open(listfname);
    listfile.getline(string,200);       //skip library name

    while (listfile)
    {
        listfile.getline(string,200);
        if (string[0]>64)
            num_files++;
    }

    listfile.close();
    cout << num_files << " files counted." << endl;
}

int main(int argc, char *argv[])
{
	if (argc == 1)
	{
		cout << "Need textfile with files to build library!" << endl;

		return 0;
	}

	strcpy(listfname, argv[1]);

	cout << "Start building library." << endl;

    count_files();      //count number of files to be included in library
    build_directory();  //build the directory of the library
	include_files();	//put all the files in the directory

	cout << "Library completed." << endl;

    return 0;
}

